#include "Circles.h"

#define CIRCLE_RADIUS 0
#define CIRCLE_SPACING 1

Circles::Circles(int typeID) : Renderable(typeID)
{
}

Circles::~Circles(void)
{
}


float Circles::GetRawValueAt(int x, int y)
{
	float xpos = x, ypos = y;
	float gray;
	m_windowMapping.PixelPositionToSpace(xpos, ypos);

	if(inCircle(xpos, ypos))
		gray = 1.0f;
	else
		gray = 0.0f;

	return gray;
}

void Circles::SetVariables()
{
	m_layerVariables[CIRCLE_RADIUS].Initialize(this, "Radius", 2.0f, 10.0f, 0.001f);
	m_layerVariables[CIRCLE_SPACING].Initialize(this, "Spacing", 2.0f, 10.0f, 0.001f);
	m_variableCount = 2;
}

bool Circles::inCircle(float x, float y)
{
	//float circleRadius = 2.0f, circleSpacing = 2.0f;
	float circleRadius = m_layerVariables[CIRCLE_RADIUS].GetValue(x, y);
	float circleSpacing = m_layerVariables[CIRCLE_SPACING].GetValue(x, y);

	x = ModFloat(x, circleRadius*2 + circleSpacing);
	y = ModFloat(y, circleRadius*2 + circleSpacing);
	if((x-circleRadius) * (x-circleRadius) + (y-circleRadius) * (y-circleRadius) < circleRadius * circleRadius)
		return true;

	return false;
}
