#pragma once
#include <utils.h>
#include "serializable.h"

class LayerVariable : public Serializable
{
public:
	LayerVariable(void);
	~LayerVariable(void);

	Renderable* GetRenderable();
	void SetRenderable(Renderable* layer);
	void RemoveRenderable();
	
	float GetValue(int x, int y);
	float GetOverrideValue();
	void SetValue(float value);

	virtual void SaveToXml(TiXmlElement *parentElement);
	virtual void LoadFromXml(TiXmlElement *parentElement);

	const char* GetName();

	void Initialize(Renderable *belongs_to, const char* newName, float overrideValue = 0.0f, float maxVal = 1.0f, float minVal = -1.0f);

	//navigation
	void MoveCoordinates(int delta_x, int delta_y);
	void IncrementZoom(float deltazoom);

private:
	//VariableType variable_type;
	float m_minValue, m_maxValue;
	char name[100];
	Renderable *renderable_value;
	Renderable *belongs_to_renderable;

	//the override value
	float m_overrideValue;
};